# Stowing (Inventory)

Endpoints to create, update and read stow jobs.

## List stow jobs

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StowJobPaginatedResult":{"properties":{"pageInfo":{"allOf":[{"$ref":"#/components/schemas/PageInfo"}],"description":"Pagination information for the search result."},"stowJobs":{"items":{"$ref":"#/components/schemas/StowJob"},"type":"array"},"total":{"description":"The total number of items matching the search criteria. Only filled, if withTotal is set to true in the search options.","minimum":0,"type":"number"}},"required":["pageInfo","stowJobs"],"title":"StowJobPaginatedResult","type":"object","description":"StowJobPaginatedResult"},"PageInfo":{"properties":{"endCursor":{"description":"The cursor to use to fetch the next page of items. Use with parameter `after`.","type":"string"},"hasNextPage":{"description":"If true, there are more items after the current page.","type":"boolean"},"hasPreviousPage":{"description":"If true, there are more items before the current page.","type":"boolean"},"startCursor":{"description":"The cursor to use to fetch the previous page of items.","type":"string"}},"required":["hasNextPage","hasPreviousPage","startCursor","endCursor"],"title":"PageInfo","type":"object","description":"PageInfo"},"StowJob":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"$ref":"#/components/schemas/AssignedUser"},"maxItems":20,"type":"array"},"created":{"description":"Creation date of the entity, auto-generated if not provided","format":"date-time","type":"string"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"facilityRef":{"description":"Non-human-readable reference to the facility where the stow job is executed","type":"string"},"id":{"description":"Auto-generated, unique primary identifier of the stow job","type":"string"},"lastModified":{"description":"Service-generated last modification date of the entity","format":"date-time","type":"string"},"priority":{"description":"Priority level of the job","type":"number"},"shortId":{"description":"Readable identifier for display purposes, not unique.","type":"string"},"status":{"description":"The status of the stowJob","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"stowLineItems":{"description":"The line items that should be stowed","items":{"$ref":"#/components/schemas/StowLineItem"},"type":"array"},"targetTime":{"description":"The time by which the job should be completed. Use for prioritization and scheduling","format":"date-time","type":"string"},"version":{"description":"The version of the entity, used for optimistic locking mechanisms","type":"number"}},"required":["facilityRef","status","stowLineItems","id","version"],"title":"StowJob","type":"object","description":"StowJob"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"StowLineItem":{"properties":{"article":{"$ref":"#/components/schemas/StowLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"heldStockRef":{"description":"Reference to a stock holding the goods after a take and before a stow has taken place","type":"string"},"id":{"description":"The ID of the stowLineItem. It is generated automatically during creation and serves as primary identifier of the entity","type":"string"},"reasons":{"description":"The reasons for the stow operation","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonOutput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToWithId"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFrom"}],"description":"Instructions on how and where to take the item from"}},"required":["article","stowTo","takeFrom","id"],"title":"StowLineItem","type":"object","description":"StowLineItem"},"StowLineItemArticle":{"properties":{"titleLocalized":{"description":"The translations for the title of the item","type":"object"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this item. Please make sure that no authentication is required to fetch the image!","type":"string"},"measurementUnitKey":{"description":"Identifier for the item's unit of measurement","type":"string"},"scannableCodes":{"description":"ScannableCodes such as barcodes related to the item","items":{"type":"string"},"type":"array"},"tenantArticleId":{"description":"Identifier for a certain product which the StowLineItem refers to","type":"string"},"title":{"description":"The title of the item","type":"string"}},"required":["tenantArticleId"],"title":"StowLineItemArticle","type":"object","description":"StowLineItemArticle"},"ExternalStockChangeReasonOutput":{"properties":{"reasonLocalized":{"description":"Localized reason strings","type":"object"},"tenantReasonId":{"description":"tenantReasonId of reason","type":"string"}},"required":["reasonLocalized"],"title":"ExternalStockChangeReasonOutput","type":"object","description":"ExternalStockChangeReasonOutput"},"StowLineItemStowToWithId":{"properties":{"id":{"description":"The ID of the stowTo instruction","type":"string"},"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowTo"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type","id"],"title":"StowLineItemStowToWithId","type":"object","description":"StowLineItemStowToWithId"},"StowedStowLineItemStowTo":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowTo","type":"object","description":"StowedStowLineItemStowTo"},"StowLineItemTakeFrom":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFrom"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFrom","type":"object","description":"StowLineItemTakeFrom"},"StowJobStockInformation":{"properties":{"properties":{"additionalProperties":{"type":"string"},"allOf":[{"$ref":"#/components/schemas/StockPropertyPreset"}],"description":"allow tracking of specific values such as expiry dates on a set of items. They should describe physical identifiable properties of the stock and are not meant to be used for metadata (see \"customAttributes\" for that)."},"traitConfig":{"items":{"$ref":"#/components/schemas/StorageLocationTraitConfigEntry"},"type":"array"}},"title":"StowJobStockInformation","type":"object","description":"StowJobStockInformation"},"StockPropertyPreset":{"properties":{"expiry":{"type":"string"}},"title":"StockPropertyPreset","type":"object","description":"StockPropertyPreset"},"StorageLocationTraitConfigEntry":{"properties":{"enabled":{"description":"whether the trait is enabled or not","type":"boolean"},"trait":{"description":"Describes what kind of actions this stock is available for\n     * `PICKABLE`- The stock is available for picking\n     * `ACCESSIBLE`- The stock is available for stock movements (stowing, inbound, etc)\n     * `KEEP_ON_ZERO`- The stock will not be deleted when emptied\n     * `OUTBOUND`- The stock is intended for outbound processes","type":"string"}},"required":["enabled","trait"],"title":"StorageLocationTraitConfigEntry","type":"object","description":"StorageLocationTraitConfigEntry"},"TakenStowLineItemTakeFrom":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFrom","type":"object","description":"TakenStowLineItemTakeFrom"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs":{"get":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"getStowJobs","parameters":[{"in":"query","name":"size","required":false,"schema":{"default":25,"maximum":100,"minimum":1,"type":"number"}},{"in":"query","name":"startAfterId","required":false,"schema":{"type":"string"}},{"in":"query","name":"sort","required":false,"schema":{"enum":["LAST_MODIFIED_ASC","LAST_MODIFIED_DESC"],"type":"string"}},{"in":"query","name":"facilityRef","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"in":"query","name":"tenantArticleId","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"in":"query","name":"locationRef","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"explode":false,"in":"query","name":"status","required":false,"schema":{"items":{"enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"type":"array"}},{"in":"query","name":"stockRef","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"in":"query","name":"shortId","required":false,"schema":{"items":{"type":"string"},"type":"array"}},{"in":"query","name":"priority","required":false,"schema":{"items":{"type":"number"},"type":"array"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJobPaginatedResult"}}},"description":"Paginated result containing the matching Stow Job entities"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"}},"summary":"List stow jobs","tags":["Stowing (Inventory)"]}}}}
```

## Create stow job

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StowJobForCreation":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"anyOf":[{"$ref":"#/components/schemas/AssignedUserForCreationById"},{"$ref":"#/components/schemas/AssignedUserForCreationByName"},{"$ref":"#/components/schemas/AssignedUser"}]},"maxItems":20,"type":"array"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"facilityRef":{"description":"Non-human-readable reference to the facility where the stow job is executed","type":"string"},"priority":{"description":"Priority level of the job","type":"number"},"shortId":{"description":"Readable identifier for display purposes, not unique.","type":"string"},"status":{"description":"The status of the stowJob","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"stowLineItems":{"description":"The line items that should be stowed","items":{"$ref":"#/components/schemas/StowLineItemForCreation"},"type":"array"},"targetTime":{"description":"The time by which the job should be completed. Use for prioritization and scheduling","format":"date-time","type":"string"}},"required":["facilityRef","status","stowLineItems"],"title":"StowJobForCreation","type":"object","description":"StowJobForCreation"},"AssignedUserForCreationById":{"description":"Create a assigned user by giving a valid id","properties":{"userId":{"description":"userId of the user should be assigned","type":"string"}},"required":["userId"],"title":"AssignedUserForCreationById","type":"object"},"AssignedUserForCreationByName":{"description":"Create a assigned user by giving a valid name","properties":{"username":{"description":"username of the user should be assigned","type":"string"}},"required":["username"],"title":"AssignedUserForCreationByName","type":"object"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"StowLineItemForCreation":{"properties":{"article":{"$ref":"#/components/schemas/StowLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"reasons":{"description":"The reasons for the stow operation. Each reason can either be a stand-alone reason, or a preconfigured reasons by specifying the tenantReasonId and/or the id of the reason. If tenantReasonId and id are specified, they have to match.","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonInput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToForCreation"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFromForCreation"}],"description":"Instructions on how and where to take the item from"}},"required":["article","stowTo","takeFrom"],"title":"StowLineItemForCreation","type":"object","description":"StowLineItemForCreation"},"StowLineItemArticle":{"properties":{"titleLocalized":{"description":"The translations for the title of the item","type":"object"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this item. Please make sure that no authentication is required to fetch the image!","type":"string"},"measurementUnitKey":{"description":"Identifier for the item's unit of measurement","type":"string"},"scannableCodes":{"description":"ScannableCodes such as barcodes related to the item","items":{"type":"string"},"type":"array"},"tenantArticleId":{"description":"Identifier for a certain product which the StowLineItem refers to","type":"string"},"title":{"description":"The title of the item","type":"string"}},"required":["tenantArticleId"],"title":"StowLineItemArticle","type":"object","description":"StowLineItemArticle"},"ExternalStockChangeReasonInput":{"properties":{"reasonLocalized":{"description":"List of localized reason strings. If provided, no preconfiguration is necessary. Cannot be provided in combination with id or existing tenantReasonId.","type":"object"},"id":{"description":"ID of reason. Use to enrich with preconfigured reason","type":"string"},"tenantReasonId":{"description":"tenantReasonId of reason. If no reasonLocalized provided, a preconfigured reason with the tenantReasonId must be present","type":"string"}},"title":"ExternalStockChangeReasonInput","type":"object","description":"ExternalStockChangeReasonInput"},"StowLineItemStowToForCreation":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowToForCreation"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemStowToForCreation","type":"object","description":"StowLineItemStowToForCreation"},"StowedStowLineItemStowToForCreation":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed. Will be set to the current time if not provided.","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowToForCreation","type":"object","description":"StowedStowLineItemStowToForCreation"},"StowLineItemTakeFromForCreation":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFromForCreation"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFromForCreation","type":"object","description":"StowLineItemTakeFromForCreation"},"StowJobStockInformation":{"properties":{"properties":{"additionalProperties":{"type":"string"},"allOf":[{"$ref":"#/components/schemas/StockPropertyPreset"}],"description":"allow tracking of specific values such as expiry dates on a set of items. They should describe physical identifiable properties of the stock and are not meant to be used for metadata (see \"customAttributes\" for that)."},"traitConfig":{"items":{"$ref":"#/components/schemas/StorageLocationTraitConfigEntry"},"type":"array"}},"title":"StowJobStockInformation","type":"object","description":"StowJobStockInformation"},"StockPropertyPreset":{"properties":{"expiry":{"type":"string"}},"title":"StockPropertyPreset","type":"object","description":"StockPropertyPreset"},"StorageLocationTraitConfigEntry":{"properties":{"enabled":{"description":"whether the trait is enabled or not","type":"boolean"},"trait":{"description":"Describes what kind of actions this stock is available for\n     * `PICKABLE`- The stock is available for picking\n     * `ACCESSIBLE`- The stock is available for stock movements (stowing, inbound, etc)\n     * `KEEP_ON_ZERO`- The stock will not be deleted when emptied\n     * `OUTBOUND`- The stock is intended for outbound processes","type":"string"}},"required":["enabled","trait"],"title":"StorageLocationTraitConfigEntry","type":"object","description":"StorageLocationTraitConfigEntry"},"TakenStowLineItemTakeFromForCreation":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFromForCreation","type":"object","description":"TakenStowLineItemTakeFromForCreation"},"StowJob":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"$ref":"#/components/schemas/AssignedUser"},"maxItems":20,"type":"array"},"created":{"description":"Creation date of the entity, auto-generated if not provided","format":"date-time","type":"string"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"facilityRef":{"description":"Non-human-readable reference to the facility where the stow job is executed","type":"string"},"id":{"description":"Auto-generated, unique primary identifier of the stow job","type":"string"},"lastModified":{"description":"Service-generated last modification date of the entity","format":"date-time","type":"string"},"priority":{"description":"Priority level of the job","type":"number"},"shortId":{"description":"Readable identifier for display purposes, not unique.","type":"string"},"status":{"description":"The status of the stowJob","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"stowLineItems":{"description":"The line items that should be stowed","items":{"$ref":"#/components/schemas/StowLineItem"},"type":"array"},"targetTime":{"description":"The time by which the job should be completed. Use for prioritization and scheduling","format":"date-time","type":"string"},"version":{"description":"The version of the entity, used for optimistic locking mechanisms","type":"number"}},"required":["facilityRef","status","stowLineItems","id","version"],"title":"StowJob","type":"object","description":"StowJob"},"StowLineItem":{"properties":{"article":{"$ref":"#/components/schemas/StowLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"heldStockRef":{"description":"Reference to a stock holding the goods after a take and before a stow has taken place","type":"string"},"id":{"description":"The ID of the stowLineItem. It is generated automatically during creation and serves as primary identifier of the entity","type":"string"},"reasons":{"description":"The reasons for the stow operation","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonOutput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToWithId"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFrom"}],"description":"Instructions on how and where to take the item from"}},"required":["article","stowTo","takeFrom","id"],"title":"StowLineItem","type":"object","description":"StowLineItem"},"ExternalStockChangeReasonOutput":{"properties":{"reasonLocalized":{"description":"Localized reason strings","type":"object"},"tenantReasonId":{"description":"tenantReasonId of reason","type":"string"}},"required":["reasonLocalized"],"title":"ExternalStockChangeReasonOutput","type":"object","description":"ExternalStockChangeReasonOutput"},"StowLineItemStowToWithId":{"properties":{"id":{"description":"The ID of the stowTo instruction","type":"string"},"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowTo"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type","id"],"title":"StowLineItemStowToWithId","type":"object","description":"StowLineItemStowToWithId"},"StowedStowLineItemStowTo":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowTo","type":"object","description":"StowedStowLineItemStowTo"},"StowLineItemTakeFrom":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFrom"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFrom","type":"object","description":"StowLineItemTakeFrom"},"TakenStowLineItemTakeFrom":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFrom","type":"object","description":"TakenStowLineItemTakeFrom"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs":{"post":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"createStowJob","parameters":[],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJobForCreation"}}},"required":true},"responses":{"201":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJob"}}},"description":"Created Stow Job entity"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"The syntax of the request content was correct, but it was unable to process the contained instructions, possibly due to semantic errors."}},"summary":"Create stow job","tags":["Stowing (Inventory)"]}}}}
```

## Get stow job

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StowJob":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"$ref":"#/components/schemas/AssignedUser"},"maxItems":20,"type":"array"},"created":{"description":"Creation date of the entity, auto-generated if not provided","format":"date-time","type":"string"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"facilityRef":{"description":"Non-human-readable reference to the facility where the stow job is executed","type":"string"},"id":{"description":"Auto-generated, unique primary identifier of the stow job","type":"string"},"lastModified":{"description":"Service-generated last modification date of the entity","format":"date-time","type":"string"},"priority":{"description":"Priority level of the job","type":"number"},"shortId":{"description":"Readable identifier for display purposes, not unique.","type":"string"},"status":{"description":"The status of the stowJob","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"stowLineItems":{"description":"The line items that should be stowed","items":{"$ref":"#/components/schemas/StowLineItem"},"type":"array"},"targetTime":{"description":"The time by which the job should be completed. Use for prioritization and scheduling","format":"date-time","type":"string"},"version":{"description":"The version of the entity, used for optimistic locking mechanisms","type":"number"}},"required":["facilityRef","status","stowLineItems","id","version"],"title":"StowJob","type":"object","description":"StowJob"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"StowLineItem":{"properties":{"article":{"$ref":"#/components/schemas/StowLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"heldStockRef":{"description":"Reference to a stock holding the goods after a take and before a stow has taken place","type":"string"},"id":{"description":"The ID of the stowLineItem. It is generated automatically during creation and serves as primary identifier of the entity","type":"string"},"reasons":{"description":"The reasons for the stow operation","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonOutput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToWithId"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFrom"}],"description":"Instructions on how and where to take the item from"}},"required":["article","stowTo","takeFrom","id"],"title":"StowLineItem","type":"object","description":"StowLineItem"},"StowLineItemArticle":{"properties":{"titleLocalized":{"description":"The translations for the title of the item","type":"object"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this item. Please make sure that no authentication is required to fetch the image!","type":"string"},"measurementUnitKey":{"description":"Identifier for the item's unit of measurement","type":"string"},"scannableCodes":{"description":"ScannableCodes such as barcodes related to the item","items":{"type":"string"},"type":"array"},"tenantArticleId":{"description":"Identifier for a certain product which the StowLineItem refers to","type":"string"},"title":{"description":"The title of the item","type":"string"}},"required":["tenantArticleId"],"title":"StowLineItemArticle","type":"object","description":"StowLineItemArticle"},"ExternalStockChangeReasonOutput":{"properties":{"reasonLocalized":{"description":"Localized reason strings","type":"object"},"tenantReasonId":{"description":"tenantReasonId of reason","type":"string"}},"required":["reasonLocalized"],"title":"ExternalStockChangeReasonOutput","type":"object","description":"ExternalStockChangeReasonOutput"},"StowLineItemStowToWithId":{"properties":{"id":{"description":"The ID of the stowTo instruction","type":"string"},"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowTo"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type","id"],"title":"StowLineItemStowToWithId","type":"object","description":"StowLineItemStowToWithId"},"StowedStowLineItemStowTo":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowTo","type":"object","description":"StowedStowLineItemStowTo"},"StowLineItemTakeFrom":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFrom"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFrom","type":"object","description":"StowLineItemTakeFrom"},"StowJobStockInformation":{"properties":{"properties":{"additionalProperties":{"type":"string"},"allOf":[{"$ref":"#/components/schemas/StockPropertyPreset"}],"description":"allow tracking of specific values such as expiry dates on a set of items. They should describe physical identifiable properties of the stock and are not meant to be used for metadata (see \"customAttributes\" for that)."},"traitConfig":{"items":{"$ref":"#/components/schemas/StorageLocationTraitConfigEntry"},"type":"array"}},"title":"StowJobStockInformation","type":"object","description":"StowJobStockInformation"},"StockPropertyPreset":{"properties":{"expiry":{"type":"string"}},"title":"StockPropertyPreset","type":"object","description":"StockPropertyPreset"},"StorageLocationTraitConfigEntry":{"properties":{"enabled":{"description":"whether the trait is enabled or not","type":"boolean"},"trait":{"description":"Describes what kind of actions this stock is available for\n     * `PICKABLE`- The stock is available for picking\n     * `ACCESSIBLE`- The stock is available for stock movements (stowing, inbound, etc)\n     * `KEEP_ON_ZERO`- The stock will not be deleted when emptied\n     * `OUTBOUND`- The stock is intended for outbound processes","type":"string"}},"required":["enabled","trait"],"title":"StorageLocationTraitConfigEntry","type":"object","description":"StorageLocationTraitConfigEntry"},"TakenStowLineItemTakeFrom":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFrom","type":"object","description":"TakenStowLineItemTakeFrom"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs/{stowJobId}":{"get":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"getStowJob","parameters":[{"in":"path","name":"stowJobId","required":true,"schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJob"}}},"description":"Requested Stow Job entity"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"The requested entity was not found"}},"summary":"Get stow job","tags":["Stowing (Inventory)"]}}}}
```

## Update stow job

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StowJobForPatch":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"anyOf":[{"$ref":"#/components/schemas/AssignedUserForCreationById"},{"$ref":"#/components/schemas/AssignedUserForCreationByName"},{"$ref":"#/components/schemas/AssignedUser"}]},"maxItems":20,"type":"array"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"priority":{"description":"Information for user about which job should be started first","type":"number"},"targetTime":{"format":"date-time","type":"string"},"version":{"description":"The version of the document to be used in optimistic locking mechanisms","type":"number"}},"required":["version"],"title":"StowJobForPatch","type":"object","description":"StowJobForPatch"},"AssignedUserForCreationById":{"description":"Create a assigned user by giving a valid id","properties":{"userId":{"description":"userId of the user should be assigned","type":"string"}},"required":["userId"],"title":"AssignedUserForCreationById","type":"object"},"AssignedUserForCreationByName":{"description":"Create a assigned user by giving a valid name","properties":{"username":{"description":"username of the user should be assigned","type":"string"}},"required":["username"],"title":"AssignedUserForCreationByName","type":"object"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs/{stowJobId}":{"patch":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"Patch StowJob","parameters":[{"in":"path","name":"stowJobId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJobForPatch"}}},"required":true},"responses":{"200":{"description":"Stow Job successfully patched"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"A version conflict occurred."},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"The syntax of the request content was correct, but it was unable to process the contained instructions, possibly due to semantic errors."}},"summary":"Update stow job","tags":["Stowing (Inventory)"]}}}}
```

## Call stow job action

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StartStowJobAction":{"description":"Sets the status of the stowjob to IN_PROGRESS","properties":{"name":{"description":"The name of the action that should be performed","enum":["START_STOW_JOB"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name"],"title":"StartStowJobAction","type":"object"},"PauseStowJobAction":{"description":"Sets the status of the stowjob to PAUSED","properties":{"name":{"description":"The name of the action that should be performed","enum":["PAUSE_STOW_JOB"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name"],"title":"PauseStowJobAction","type":"object"},"CancelStowJobAction":{"description":"Sets the status of the stowjob to CANCELED","properties":{"name":{"description":"The name of the action that should be performed","enum":["CANCEL_STOW_JOB"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name"],"title":"CancelStowJobAction","type":"object"},"ReopenStowJobAction":{"description":"Sets the status of the stowjob to OPEN","properties":{"name":{"description":"The name of the action that should be performed","enum":["OPEN_STOW_JOB"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name"],"title":"ReopenStowJobAction","type":"object"},"CloseStowJobAction":{"description":"Sets the status of the stowjob to CLOSED","properties":{"name":{"description":"The name of the action that should be performed","enum":["CLOSE_STOW_JOB"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name"],"title":"CloseStowJobAction","type":"object"},"ModifyStowLineItemsAction":{"description":"MODIFY_STOW_LINE_ITEMS targets specific stowJob.stowLineItems by ID. Each targeted entry is partially updated: provided fields are completely replaced, while unspecified fields remain unchanged. New entries can be added by omitting the ID field.","properties":{"name":{"description":"The name of the action that should be performed","enum":["MODIFY_STOW_LINE_ITEMS"],"type":"string"},"stowLineItems":{"items":{"$ref":"#/components/schemas/StowLineItemForUpdate"},"type":"array"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name","stowLineItems"],"title":"ModifyStowLineItemsAction","type":"object"},"StowLineItemForUpdate":{"properties":{"article":{"allOf":[{"$ref":"#/components/schemas/StowLineItemArticle"}],"description":"The article that should be stowed"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"id":{"description":"The ID of the stowLineItem. Leave empty for creation","type":"string"},"reasons":{"description":"The reasons for the stow operation","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonInput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToForUpdate"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFromForCreation"}],"description":"Instructions on how and where to take the item from"}},"title":"StowLineItemForUpdate","type":"object","description":"StowLineItemForUpdate"},"StowLineItemArticle":{"properties":{"titleLocalized":{"description":"The translations for the title of the item","type":"object"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this item. Please make sure that no authentication is required to fetch the image!","type":"string"},"measurementUnitKey":{"description":"Identifier for the item's unit of measurement","type":"string"},"scannableCodes":{"description":"ScannableCodes such as barcodes related to the item","items":{"type":"string"},"type":"array"},"tenantArticleId":{"description":"Identifier for a certain product which the StowLineItem refers to","type":"string"},"title":{"description":"The title of the item","type":"string"}},"required":["tenantArticleId"],"title":"StowLineItemArticle","type":"object","description":"StowLineItemArticle"},"ExternalStockChangeReasonInput":{"properties":{"reasonLocalized":{"description":"List of localized reason strings. If provided, no preconfiguration is necessary. Cannot be provided in combination with id or existing tenantReasonId.","type":"object"},"id":{"description":"ID of reason. Use to enrich with preconfigured reason","type":"string"},"tenantReasonId":{"description":"tenantReasonId of reason. If no reasonLocalized provided, a preconfigured reason with the tenantReasonId must be present","type":"string"}},"title":"ExternalStockChangeReasonInput","type":"object","description":"ExternalStockChangeReasonInput"},"StowLineItemStowToForUpdate":{"properties":{"id":{"type":"string"},"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowToForCreation"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemStowToForUpdate","type":"object","description":"StowLineItemStowToForUpdate"},"StowedStowLineItemStowToForCreation":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed. Will be set to the current time if not provided.","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowToForCreation","type":"object","description":"StowedStowLineItemStowToForCreation"},"StowLineItemTakeFromForCreation":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFromForCreation"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFromForCreation","type":"object","description":"StowLineItemTakeFromForCreation"},"StowJobStockInformation":{"properties":{"properties":{"additionalProperties":{"type":"string"},"allOf":[{"$ref":"#/components/schemas/StockPropertyPreset"}],"description":"allow tracking of specific values such as expiry dates on a set of items. They should describe physical identifiable properties of the stock and are not meant to be used for metadata (see \"customAttributes\" for that)."},"traitConfig":{"items":{"$ref":"#/components/schemas/StorageLocationTraitConfigEntry"},"type":"array"}},"title":"StowJobStockInformation","type":"object","description":"StowJobStockInformation"},"StockPropertyPreset":{"properties":{"expiry":{"type":"string"}},"title":"StockPropertyPreset","type":"object","description":"StockPropertyPreset"},"StorageLocationTraitConfigEntry":{"properties":{"enabled":{"description":"whether the trait is enabled or not","type":"boolean"},"trait":{"description":"Describes what kind of actions this stock is available for\n     * `PICKABLE`- The stock is available for picking\n     * `ACCESSIBLE`- The stock is available for stock movements (stowing, inbound, etc)\n     * `KEEP_ON_ZERO`- The stock will not be deleted when emptied\n     * `OUTBOUND`- The stock is intended for outbound processes","type":"string"}},"required":["enabled","trait"],"title":"StorageLocationTraitConfigEntry","type":"object","description":"StorageLocationTraitConfigEntry"},"TakenStowLineItemTakeFromForCreation":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFromForCreation","type":"object","description":"TakenStowLineItemTakeFromForCreation"},"StowJobReplaceAssignedUsersAction":{"description":"REPLACE_ASSIGNED_USERS replaces the assigned users of the stow job","properties":{"assignedUsers":{"description":"The users are assigned to the stow job","items":{"anyOf":[{"$ref":"#/components/schemas/AssignedUserForCreationById"},{"$ref":"#/components/schemas/AssignedUserForCreationByName"},{"$ref":"#/components/schemas/AssignedUser"}]},"maxItems":20,"type":"array"},"name":{"description":"The name of the action that should be performed","enum":["REPLACE_ASSIGNED_USERS"],"type":"string"},"version":{"description":"The current version of the stow job that should be modified","type":"number"}},"required":["version","name","assignedUsers"],"title":"StowJobReplaceAssignedUsersAction","type":"object"},"AssignedUserForCreationById":{"description":"Create a assigned user by giving a valid id","properties":{"userId":{"description":"userId of the user should be assigned","type":"string"}},"required":["userId"],"title":"AssignedUserForCreationById","type":"object"},"AssignedUserForCreationByName":{"description":"Create a assigned user by giving a valid name","properties":{"username":{"description":"username of the user should be assigned","type":"string"}},"required":["username"],"title":"AssignedUserForCreationByName","type":"object"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs/{stowJobId}/actions":{"post":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />","operationId":"Post StowJob Actions","parameters":[{"in":"path","name":"stowJobId","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"oneOf":[{"$ref":"#/components/schemas/StartStowJobAction"},{"$ref":"#/components/schemas/PauseStowJobAction"},{"$ref":"#/components/schemas/CancelStowJobAction"},{"$ref":"#/components/schemas/ReopenStowJobAction"},{"$ref":"#/components/schemas/CloseStowJobAction"},{"$ref":"#/components/schemas/ModifyStowLineItemsAction"},{"$ref":"#/components/schemas/StowJobReplaceAssignedUsersAction"}]}}},"required":true},"responses":{"200":{"description":"Actions successfully performed"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"},"404":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"The requested entity was not found"},"409":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"A version conflict occurred."},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"The syntax of the request content was correct, but it was unable to process the contained instructions, possibly due to semantic errors."}},"summary":"Call stow job action","tags":["Stowing (Inventory)"]}}}}
```

## List stow jobs (search)

> This part of the API is in Beta status. For details please check the \<a href="<https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta>" target="\_blank">api-release-life-cycle documentation\</a>.\<br />\<br />Search for StowJob

```json
{"openapi":"3.0.1","info":{"title":"fulfillmenttools","version":"VERSIONLESS"},"tags":[{"description":"Endpoints to create, update, and read stow jobs.","name":"Stowing (Inventory)"}],"servers":[{"url":"https://{tenant}.api.fulfillmenttools.com","variables":{"tenant":{"default":"your-tenant-name"}}}],"security":[{"BearerToken":[]}],"components":{"securitySchemes":{"BearerToken":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StowJobSearchPayload":{"properties":{"after":{"deprecated":false,"description":"The cursor to start after for forward pagination. The value is provided in the `pageInfo.endCursor` field of the response. Cannot be used with `before` or `last`.","type":"string"},"before":{"description":"The cursor to start before for backward pagination. The value is provided in the `pageInfo.startCursor` field of the response. Cannot be used with `after` or `size` (first).","type":"string"},"last":{"description":"Number of items to return for backward pagination. Cannot be used with 'size' (first). Default: 20.","maximum":250,"minimum":1,"type":"number"},"options":{"$ref":"#/components/schemas/SearchOptions"},"query":{"$ref":"#/components/schemas/StowJobSearchQuery"},"size":{"description":"Number of items to return for forward pagination. Cannot be used with 'last'. Default: 20.","maximum":250,"minimum":1,"type":"number"},"sort":{"description":"Use for sorting the result.","items":{"$ref":"#/components/schemas/StowJobSort"},"maxItems":1,"minItems":1,"type":"array"},"startAfterId":{"deprecated":true,"description":"The ID to start after. Deprecated, use `after` with the value provided in `pageInfo.endCursor` instead.","type":"string"}},"required":["query"],"title":"StowJobSearchPayload","type":"object","description":"StowJobSearchPayload"},"SearchOptions":{"properties":{"withTotal":{"description":"Set to true to include the total count of items in the search result.","type":"boolean"}},"title":"SearchOptions","type":"object","description":"SearchOptions"},"StowJobSearchQuery":{"properties":{"and":{"items":{"$ref":"#/components/schemas/StowJobSearchQuery"},"maxItems":500,"type":"array"},"created":{"allOf":[{"$ref":"#/components/schemas/DateFilter"}],"default":{"after":"-P1W"},"description":"Search entries by created. Applying a narrow and well-considered filter value is strongly recommended, as it can greatly improve response times, especially when working with large datasets."},"customAttributes":{"additionalProperties":{"anyOf":[{"$ref":"#/components/schemas/BooleanFilter"},{"$ref":"#/components/schemas/StringEqFilter"},{"$ref":"#/components/schemas/NumberEqFilter"},{"$ref":"#/components/schemas/DateFilter"}]},"description":"Search by custom attributes","type":"object"},"facilityRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by facilityRef"},"id":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by id"},"or":{"items":{"$ref":"#/components/schemas/StowJobSearchQuery"},"maxItems":500,"type":"array"},"priority":{"allOf":[{"$ref":"#/components/schemas/NumberFilter"}],"description":"Search by priority"},"shortId":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by shortId"},"status":{"allOf":[{"$ref":"#/components/schemas/StowJobStatusTypeEnumFilter"}],"description":"Search by status"},"stowLineItems":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsListFilter"}],"description":"Nested list search by stowLineItems"},"targetTime":{"allOf":[{"$ref":"#/components/schemas/DateFilter"}],"description":"Search by targetTime"}},"title":"StowJobSearchQuery","type":"object","description":"StowJobSearchQuery"},"DateFilter":{"properties":{"after":{"description":"Search using ISO‑8601 dates relative to today. Prefix with “–” for past dates. Results include events after the specified date. Example: “–P1D” for yesterday, “P1W” for next week.","maxLength":256,"type":"string"},"before":{"description":"Search using ISO‑8601 dates relative to today. Prefix with “–” for past dates. Results include events before the specified date. Example: “–P1D” for yesterday, “P1W” for next week.","maxLength":256,"type":"string"},"eq":{"format":"date-time","type":"string"},"gt":{"format":"date-time","type":"string"},"gte":{"format":"date-time","type":"string"},"lt":{"format":"date-time","type":"string"},"lte":{"format":"date-time","type":"string"},"notEq":{"format":"date-time","type":"string"}},"title":"DateFilter","type":"object","description":"DateFilter"},"BooleanFilter":{"properties":{"eq":{"type":"boolean"},"notEq":{"type":"boolean"}},"title":"BooleanFilter","type":"object","description":"BooleanFilter"},"StringEqFilter":{"properties":{"eq":{"maxLength":256,"type":"string"},"notEq":{"maxLength":256,"type":"string"}},"title":"StringEqFilter","type":"object","description":"StringEqFilter"},"NumberEqFilter":{"properties":{"eq":{"type":"number"},"gt":{"type":"number"},"gte":{"type":"number"},"lt":{"type":"number"},"lte":{"type":"number"},"notEq":{"type":"number"}},"title":"NumberEqFilter","type":"object","description":"NumberEqFilter"},"StringFilter":{"properties":{"eq":{"maxLength":256,"type":"string"},"in":{"items":{"maxLength":256,"type":"string"},"maxItems":25,"type":"array"},"notEq":{"maxLength":256,"type":"string"},"notIn":{"items":{"maxLength":256,"type":"string"},"maxItems":25,"type":"array"}},"title":"StringFilter","type":"object","description":"StringFilter"},"NumberFilter":{"properties":{"eq":{"type":"number"},"gt":{"type":"number"},"gte":{"type":"number"},"in":{"items":{"type":"number"},"maxItems":25,"type":"array"},"lt":{"type":"number"},"lte":{"type":"number"},"notEq":{"type":"number"},"notIn":{"items":{"type":"number"},"maxItems":25,"type":"array"}},"title":"NumberFilter","type":"object","description":"NumberFilter"},"StowJobStatusTypeEnumFilter":{"properties":{"eq":{"description":"Search by status","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"in":{"description":"Search by status","items":{"enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"maxItems":500,"type":"array"},"notEq":{"description":"Search by status","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"}},"title":"StowJobStatusTypeEnumFilter","type":"object","description":"StowJobStatusTypeEnumFilter"},"StowJobStowLineItemsListFilter":{"properties":{"contains":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsFilter"}],"description":"Contains returns if at least one entry matches"}},"title":"StowJobStowLineItemsListFilter","type":"object","description":"StowJobStowLineItemsListFilter"},"StowJobStowLineItemsFilter":{"properties":{"article":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsArticleFilter"}],"description":"Nested search by article"},"heldStockRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by heldStockRef"},"id":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by id"},"stowTo":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsStowToListFilter"}],"description":"Nested list search by stowTo"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsTakeFromFilter"}],"description":"Nested search by takeFrom"}},"title":"StowJobStowLineItemsFilter","type":"object","description":"StowJobStowLineItemsFilter"},"StowJobStowLineItemsArticleFilter":{"properties":{"tenantArticleId":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by tenantArticleId"}},"title":"StowJobStowLineItemsArticleFilter","type":"object","description":"StowJobStowLineItemsArticleFilter"},"StowJobStowLineItemsStowToListFilter":{"properties":{"contains":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsStowToFilter"}],"description":"Contains returns if at least one entry matches"}},"title":"StowJobStowLineItemsStowToListFilter","type":"object","description":"StowJobStowLineItemsStowToListFilter"},"StowJobStowLineItemsStowToFilter":{"properties":{"storageLocationRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by storageLocationRef"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsStowToStowedFilter"}],"description":"Nested search by stowed"},"type":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by type"}},"title":"StowJobStowLineItemsStowToFilter","type":"object","description":"StowJobStowLineItemsStowToFilter"},"StowJobStowLineItemsStowToStowedFilter":{"properties":{"stowedStockRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by stowedStockRef"},"stowedStorageLocationRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by stowedStorageLocationRef"}},"title":"StowJobStowLineItemsStowToStowedFilter","type":"object","description":"StowJobStowLineItemsStowToStowedFilter"},"StowJobStowLineItemsTakeFromFilter":{"properties":{"storageLocationRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by storageLocationRef"},"taken":{"allOf":[{"$ref":"#/components/schemas/StowJobStowLineItemsTakeFromTakenFilter"}],"description":"Nested search by taken"},"type":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by type"}},"title":"StowJobStowLineItemsTakeFromFilter","type":"object","description":"StowJobStowLineItemsTakeFromFilter"},"StowJobStowLineItemsTakeFromTakenFilter":{"properties":{"takenStockRef":{"allOf":[{"$ref":"#/components/schemas/StringFilter"}],"description":"Search by takenStockRef"}},"title":"StowJobStowLineItemsTakeFromTakenFilter","type":"object","description":"StowJobStowLineItemsTakeFromTakenFilter"},"StowJobSort":{"properties":{"created":{"enum":["ASC","DESC"],"type":"string"},"customAttributes":{"additionalProperties":true,"maxProperties":1,"minProperties":1,"type":"object"},"lastModified":{"enum":["ASC","DESC"],"type":"string"},"targetTime":{"enum":["ASC","DESC"],"type":"string"}},"title":"StowJobSort","type":"object","description":"StowJobSort"},"StowJobPaginatedResult":{"properties":{"pageInfo":{"allOf":[{"$ref":"#/components/schemas/PageInfo"}],"description":"Pagination information for the search result."},"stowJobs":{"items":{"$ref":"#/components/schemas/StowJob"},"type":"array"},"total":{"description":"The total number of items matching the search criteria. Only filled, if withTotal is set to true in the search options.","minimum":0,"type":"number"}},"required":["pageInfo","stowJobs"],"title":"StowJobPaginatedResult","type":"object","description":"StowJobPaginatedResult"},"PageInfo":{"properties":{"endCursor":{"description":"The cursor to use to fetch the next page of items. Use with parameter `after`.","type":"string"},"hasNextPage":{"description":"If true, there are more items after the current page.","type":"boolean"},"hasPreviousPage":{"description":"If true, there are more items before the current page.","type":"boolean"},"startCursor":{"description":"The cursor to use to fetch the previous page of items.","type":"string"}},"required":["hasNextPage","hasPreviousPage","startCursor","endCursor"],"title":"PageInfo","type":"object","description":"PageInfo"},"StowJob":{"properties":{"assignedUsers":{"description":"The users that are assigned to the stow job","items":{"$ref":"#/components/schemas/AssignedUser"},"maxItems":20,"type":"array"},"created":{"description":"Creation date of the entity, auto-generated if not provided","format":"date-time","type":"string"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"facilityRef":{"description":"Non-human-readable reference to the facility where the stow job is executed","type":"string"},"id":{"description":"Auto-generated, unique primary identifier of the stow job","type":"string"},"lastModified":{"description":"Service-generated last modification date of the entity","format":"date-time","type":"string"},"priority":{"description":"Priority level of the job","type":"number"},"shortId":{"description":"Readable identifier for display purposes, not unique.","type":"string"},"status":{"description":"The status of the stowJob","enum":["OPEN","IN_PROGRESS","CLOSED","CANCELED","PAUSED"],"type":"string"},"stowLineItems":{"description":"The line items that should be stowed","items":{"$ref":"#/components/schemas/StowLineItem"},"type":"array"},"targetTime":{"description":"The time by which the job should be completed. Use for prioritization and scheduling","format":"date-time","type":"string"},"version":{"description":"The version of the entity, used for optimistic locking mechanisms","type":"number"}},"required":["facilityRef","status","stowLineItems","id","version"],"title":"StowJob","type":"object","description":"StowJob"},"AssignedUser":{"properties":{"userId":{"description":"ID of the user who is assigned","type":"string"},"username":{"description":"username of the user who is assigned","type":"string"}},"required":["username","userId"],"type":"object","title":"AssignedUser","description":"AssignedUser"},"StowLineItem":{"properties":{"article":{"$ref":"#/components/schemas/StowLineItemArticle"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"heldStockRef":{"description":"Reference to a stock holding the goods after a take and before a stow has taken place","type":"string"},"id":{"description":"The ID of the stowLineItem. It is generated automatically during creation and serves as primary identifier of the entity","type":"string"},"reasons":{"description":"The reasons for the stow operation","items":{"$ref":"#/components/schemas/ExternalStockChangeReasonOutput"},"maxItems":10,"type":"array"},"stowTo":{"description":"Instructions on how and where to stow the item","items":{"$ref":"#/components/schemas/StowLineItemStowToWithId"},"type":"array"},"takeFrom":{"allOf":[{"$ref":"#/components/schemas/StowLineItemTakeFrom"}],"description":"Instructions on how and where to take the item from"}},"required":["article","stowTo","takeFrom","id"],"title":"StowLineItem","type":"object","description":"StowLineItem"},"StowLineItemArticle":{"properties":{"titleLocalized":{"description":"The translations for the title of the item","type":"object"},"customAttributes":{"description":"Attributes that can be added to this entity. These attributes **cannot** be used within fulfillment processes, but enable you to attach custom data from your systems to fulfillmenttools entities.","nullable":true,"type":"object"},"imageUrl":{"description":"A web link to a picture of this item. Please make sure that no authentication is required to fetch the image!","type":"string"},"measurementUnitKey":{"description":"Identifier for the item's unit of measurement","type":"string"},"scannableCodes":{"description":"ScannableCodes such as barcodes related to the item","items":{"type":"string"},"type":"array"},"tenantArticleId":{"description":"Identifier for a certain product which the StowLineItem refers to","type":"string"},"title":{"description":"The title of the item","type":"string"}},"required":["tenantArticleId"],"title":"StowLineItemArticle","type":"object","description":"StowLineItemArticle"},"ExternalStockChangeReasonOutput":{"properties":{"reasonLocalized":{"description":"Localized reason strings","type":"object"},"tenantReasonId":{"description":"tenantReasonId of reason","type":"string"}},"required":["reasonLocalized"],"title":"ExternalStockChangeReasonOutput","type":"object","description":"ExternalStockChangeReasonOutput"},"StowLineItemStowToWithId":{"properties":{"id":{"description":"The ID of the stowTo instruction","type":"string"},"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"stowed":{"allOf":[{"$ref":"#/components/schemas/StowedStowLineItemStowTo"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be stowed on a specific stock or storage location. Use type DISCARD if the item should be booked out of the system","enum":["STOCK","LOCATION","DISCARD"],"type":"string"}},"required":["quantity","type","id"],"title":"StowLineItemStowToWithId","type":"object","description":"StowLineItemStowToWithId"},"StowedStowLineItemStowTo":{"properties":{"stowedAt":{"description":"Time and date on which the item was stowed","format":"date-time","type":"string"},"stowedQuantity":{"description":"Quantity that was stowed","type":"number"},"stowedStockRef":{"description":"Specifies the stock where the item will be stowed. Set this to null to explicitly create a new stock. \n Exception: If stowTo.type is \"DISCARD\", a new stock will not be created when set to `null`. However, if a stock is specified, its quantity will be increased regardless of the type.","nullable":true,"type":"string"},"stowedStorageLocationRef":{"description":"If a new stock is created via stowedStockRef = null, this is used to set the storage location of the new stock. \n If a stock is specified, this field will be ignored.","type":"string"}},"required":["stowedStockRef","stowedQuantity"],"title":"StowedStowLineItemStowTo","type":"object","description":"StowedStowLineItemStowTo"},"StowLineItemTakeFrom":{"properties":{"quantity":{"description":"Quantity that should be taken / stowed","type":"number"},"scannableCodes":{"description":"ScannableCodes such as barcodes relevant for taking or stowing the item","items":{"type":"string"},"type":"array"},"stockInformation":{"allOf":[{"$ref":"#/components/schemas/StowJobStockInformation"}],"description":"Additional information about the newly created stock. **Only allowed for type UNREGISTERED**"},"stockRef":{"description":"Stock from which the item should be taken / stowed to. Leave empty for type UNREGISTERED / DISCARD.","type":"string"},"storageLocationRef":{"description":"Storage location from which the item should be taken or to which the item should be stowed","type":"string"},"taken":{"allOf":[{"$ref":"#/components/schemas/TakenStowLineItemTakeFrom"}],"description":"Operative data holding information about the stowing progress. **As for now stocks will *not* be updated even if the numbers indicate so because the stow job feature is still under development.**"},"type":{"description":"Define if items should be taken from specific stock or storage location. Use type UNREGISTERED if a new item should be booked into the system","enum":["STOCK","LOCATION","UNREGISTERED"],"type":"string"}},"required":["quantity","type"],"title":"StowLineItemTakeFrom","type":"object","description":"StowLineItemTakeFrom"},"StowJobStockInformation":{"properties":{"properties":{"additionalProperties":{"type":"string"},"allOf":[{"$ref":"#/components/schemas/StockPropertyPreset"}],"description":"allow tracking of specific values such as expiry dates on a set of items. They should describe physical identifiable properties of the stock and are not meant to be used for metadata (see \"customAttributes\" for that)."},"traitConfig":{"items":{"$ref":"#/components/schemas/StorageLocationTraitConfigEntry"},"type":"array"}},"title":"StowJobStockInformation","type":"object","description":"StowJobStockInformation"},"StockPropertyPreset":{"properties":{"expiry":{"type":"string"}},"title":"StockPropertyPreset","type":"object","description":"StockPropertyPreset"},"StorageLocationTraitConfigEntry":{"properties":{"enabled":{"description":"whether the trait is enabled or not","type":"boolean"},"trait":{"description":"Describes what kind of actions this stock is available for\n     * `PICKABLE`- The stock is available for picking\n     * `ACCESSIBLE`- The stock is available for stock movements (stowing, inbound, etc)\n     * `KEEP_ON_ZERO`- The stock will not be deleted when emptied\n     * `OUTBOUND`- The stock is intended for outbound processes","type":"string"}},"required":["enabled","trait"],"title":"StorageLocationTraitConfigEntry","type":"object","description":"StorageLocationTraitConfigEntry"},"TakenStowLineItemTakeFrom":{"properties":{"takenAt":{"description":"Time and date on which the item was taken","format":"date-time","type":"string"},"takenQuantity":{"description":"Quantity that was taken","type":"number"},"takenStockRef":{"description":"Specifies the stock from which the goods will be taken. \n Exception: If stowTo.type is \"UNREGISTERED\", this field may be null. If a stock is specified, its quantity will be reduced regardless of the type.","nullable":true,"type":"string"}},"required":["takenQuantity","takenStockRef"],"title":"TakenStowLineItemTakeFrom","type":"object","description":"TakenStowLineItemTakeFrom"},"ApiError":{"items":{"$ref":"#/components/schemas/ErrorInner"},"type":"array","xml":{"name":"ApiError"},"title":"ApiError","description":"ApiError"},"ErrorInner":{"properties":{"description":{"type":"string"},"requestVersion":{"description":"The version provided within an invalid request.","format":"int64","type":"integer"},"summary":{"type":"string"},"version":{"format":"int64","type":"integer"}},"required":["summary"],"type":"object","title":"ErrorInner","description":"ErrorInner"}}},"paths":{"/api/stowjobs/search":{"post":{"deprecated":false,"description":"This part of the API is in Beta status. For details please check the <a href=\"https://docs.fulfillmenttools.com/documentation/developer-docs/api/core-concepts/api-release-life-cycle#beta\" target=\"_blank\">api-release-life-cycle documentation</a>.<br /><br />Search for StowJob","operationId":"searchStowJob","parameters":[],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJobSearchPayload"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StowJobPaginatedResult"}}},"description":"Your search result"},"401":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user is not allowed to operate against this API instance"},"403":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiError"}}},"description":"Your user, although recognized, is not authorized to use this"}},"summary":"List stow jobs (search)","tags":["Stowing (Inventory)"]}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.fulfillmenttools.com/documentation/apis/api-reference/stowing-inventory.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
